#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <string>
#include <unistd.h>
#include <vector>
#include <algorithm>
#include <cmath>
static const char TUNNUS[] = "bisqwit";
static const char TUNNUSu[]= "Bisqwit";
static const char SALASANA[] = "hackme";

static unsigned hp,hpmax,  sp,spmax,  ep,epmax;

static bool IsPrompt(const string &s)
{
	if(sscanf(s.c_str(), "hp:%u/%u sp:%u/%u ep:%u/%u",
		&hp,&hpmax, &sp,&spmax, &ep,&epmax) != 6)
		return false;
	cerr<<"\33[1;30m"<<s<<"\33[0;37m\n";
	return true;
}

static string Gets() /* lukee rivin sytteest ja parsii siit ylimriset pois */
{
	string s;
	for(;;)
	{
		{char Buf[4096]; if(!fgets(Buf, sizeof Buf, stdin))throw 2; s=Buf; }
    	unsigned a;
    	while(s.size() && s[0]==' ')s.erase(0, 1);
    	for(a=0; a<s.size(); )
    	{
    		if(s[a]=='\n' || s[a]=='\r')
    			s.erase(a, 1);
    		else if(s[a]=='\33')
    		{
    			unsigned c;
    			for(c=a; c<s.size() && (s[c]<'a' || s[c]>'z'); ++c);
    			s.erase(a, c-a+1);
    		}
    		else
    			++a;
    	}
    	while(s.size() && s[s.size()-1]==' ')s.erase(s.size()-1);
    	
    	if(!IsPrompt(s))break;
    }
	return s;
}

static vector<string> GetExits(const string &s) /* ettii exitit rivilt */
{
	vector<string> lst;
	if(s.substr(0, 7) == "You can")return lst;
	
	if(s.size() >= 2 && s.substr(s.size()-2) == ").")
	{
		unsigned a = s.find('(');
		while(++a < s.size())
		{
			string k;
			while(s[a] != ',' && s[a] != ')')k += s[a++];
			//cerr << "\33[1mFound exit: '" << k << "'\33[m\n";
			lst.push_back(k);
			if(s[a]==')')break;
		}
	}
	random_shuffle(lst.begin(), lst.end());
	return lst;
}

static string fightcmd(bool spa, bool epa)
{
Retry:
	int i = -1;
	if(spa || epa)
	{
		i = (int)(pow(drand48(), 3) * (4 + 0.999));
	}
	switch(i)
	{
		case 0: if(!epa)goto Retry;return "use stab";
		case 1: if(!spa)goto Retry;return "cast cause serious wounds at monster";
		case 2: if(!spa)goto Retry;return "cast cause critical wounds at monster";
		case 3: if(!spa)goto Retry;return "doclw";
		case 4: if(!spa)goto Retry;return "cast make scar at monster";
		default: return "i";
	}
}

static void ForgeCheck(const string &s)
{
	if(s == "You can not take the forge."
	|| s == "You can not take a forge.")
	{
		cerr << "\33[0;1;37mFORGE! Ihaile sit :)\33[m\n";
		cout << "use ceremony\n" << flush;
		for(unsigned a=0; a<10; ++a){cerr << "\7" << flush; sleep(1); }
	}
}
static void fight()
{
	cout << fightcmd(sp >= spmax/10 || hp <= hpmax/3, ep >= epmax/4 || hp <= hpmax/3) << "\nps\n";
	for(;;)
	{
		string s = Gets();
		cerr << s << endl;
		if(s=="The maze is being re-done, please wait a while."
		|| s.find("low rumble") != s.npos)throw 1;
		if(s=="You do not have enough spell points to cast the spell.")
		{
			cout << fightcmd(sp >= spmax/10 || hp <= hpmax/3, ep >= epmax/4 || hp <= hpmax/3) << "\n";
		}
		ForgeCheck(s);
		if(s=="You are done with the chant."
		|| s=="You are prepared to do the skill.")
		{
			cout << fightcmd(sp >= spmax/10 || hp <= hpmax/3, ep >= epmax/4 || hp <= hpmax/3) << "\n";
		}
		if(s.find("is DEAD, R.I.P") != s.npos
		|| s=="At whom ?"
		|| s=="Cast make scar at what?"
		|| s=="Cast cause serious wounds at what?"
		|| s=="Cast cause critical wounds at what?"
		)
			break;
	}
}

static bool gotfight(const string &s)
{
	if(s.find("You take a dismembered entrails of") != s.npos
	|| s.find("You take a hacked yolk of") != s.npos
	|| s.find("You take a hacked entrails of") != s.npos
	|| s.find("You take a hacked corpse of") != s.npos
	|| s.find("You take a mutilated lump of") != s.npos
	|| s.find("You take a mutilated bodyparts") != s.npos
	|| s.find("You take a shredded slush of") != s.npos
	|| s.find("You take a hacked bodyparts") != s.npos)
	{
		cout << "drop all corpse\n";
	}
	if(s.find(". Too much to carry!") != s.npos)
	{
		cout << "drop all pilum|drop all broadsword|"
		        "drop all longsword|drop all spear|"
		        "drop all gauche|drop all fauchard|"
		        "drop all blackjack|drop all ranseur|"
		        "drop all harpoon|drop all corpse|i\n";
	}
	ForgeCheck(s);
	if(s=="The maze is being re-done, please wait a while."
	|| s.find("low rumble") != s.npos)throw 1;
	if(s=="The monster blocks your move."
	|| s=="You cannot leave, you have been AMBUSHED."
/*	|| s.find("Your superb dexterity") == 0 -- doesn't block */
	)
		return true;
	return false;
}

static void Regen()
{
CheckAgain:
	time_t endtime = 0;
	if(hp >= hpmax/2 && sp >= spmax/8 && ep > 30)
	{
		static unsigned counter = 0;
		if(++counter <= 5)return;
		counter = 0;
		
        unsigned sleeptime = static_cast<unsigned> (pow(drand48(), 30) * 120);
        if(!sleeptime)return;
        if(sleeptime < 5)
        {
        	cerr << "\33[0;1;37m" << sleeptime << "s paussi (inhimmillisyytt)\33[m\n";
        	sleep(sleeptime);
        	cout << "friends\n";
        	return;
        }
       	cerr << "\33[0;1;33m" << sleeptime << "s idle (inhimmillisyytt)\33[m\n";
        endtime = time(NULL) + sleeptime;
        cout << "sc on\n";
	}
	else
	{
		cerr << "\33[0;1;31mPidetn tauko.\33[m\n";
		cout << "sit\n";
		cout << "i\n";
		cout << "sc on\n";
ReWait: /* tick tack */
		cout << "use ceremony\n" << flush;
	}
	bool noneed = false;
	for(;;)
	{
		string s = Gets();
		cerr << s << endl;
		if(sscanf(s.c_str(), "Hp: %u (%u) Sp: %u (%u) Ep: %u (%u)",
			&hp,&hpmax, &sp,&spmax, &ep,&epmax) == 6)
		{
			if(noneed)
			{
				if((hp < hpmax && sp > spmax/4)
				|| (hp < hpmax*5/7 && sp>30))
				{
					noneed = false;
					goto Healer;
				}
			}
			continue;
		}
		if(s.find(string(TUNNUSu)+" hits") == 0)
		{
			fight();
			goto CheckAgain;
		}
		if(s=="The maze is being re-done, please wait a while."
		|| s.find("low rumble") != s.npos)throw 1;
		if(s=="You do not have enough spell points to cast the spell.")
			goto ReWait;
		if(s=="You are done with the chant."
		|| s=="You are prepared to do the skill.")
		{	
			if((hp >= hpmax*5/7 && sp < spmax/4)
			|| sp<=30)noneed = true;
		Healer:
			if(!noneed)cout << "doclw\n";
			continue;
		}
		if(s=="You feel fully healed."
		|| s=="You heal all of your own wounds."
		|| s.find("is not wounded.") != s.npos)
			noneed = true;
		if(endtime)
		{
			if(time(NULL) < endtime)continue;
			cout << "sc off\n";
			goto CheckAgain;
		}
		if(hp >= hpmax*5/7 && sp >= spmax/4 && ep >= epmax/6)
			break;
	}
	cout << "stand\nsc off\n";
   	for(;;)
   	{
   		string s = Gets();
   		cerr << s << endl;
   		if(s == "You stand up straight.")break;
   	}
	cerr << "\33[0;1;31mTauko pttyi.\33[m\n";
}

static void ScanRoom(const string &dir) /* rekursio */
{
	const string opposite
	  = dir=="u" ? "d"
	  : dir=="d" ? "u"
	  : dir=="w" ? "e"
	  : dir=="e" ? "w"
	  : dir=="n" ? "s"
	  : dir=="s" ? "n"
	  : dir=="sw" ? "ne"
	  : dir=="nw" ? "se"
	  : dir=="ne" ? "sw"
	  : dir=="se" ? "nw"
	  : dir=="forward" ? "backward"
	  : dir=="backward" ? "forward"
	  : "";

Retry:	
	//cerr << "\33[0;32m> " << dir << "\33[m\n";
	//cerr << "\33[0;32m> ga\33[m\n";
	Regen();
	cerr << "\33[0;1;31m-> '" << dir << "' - backdir = '" << opposite << "'\33[m\n";
	cout << dir << "\nga\n";
		
	for(;;)
	{
		string s = Gets();
		cerr << s << endl;
       	if(s=="You are so exhausted you fail to move.")
       	{
       		goto Retry;
       	}
		/*if(s.find("is looking for adventurers to eat") != s.npos)
		{
			cout << "kill monster\n";
			goto Monsu;
		}*/
		if(s.find("A strong force stops you from going") == 0)
		{
			cerr << "\33[0;1;34mEi sitten\33[m\n";
			return;
		}
		if(gotfight(s))
		{
Monsu:		cerr << "\33[0;1;35mOdotellaan monsterin kuolemista\33[m\n";
			fight();
			cerr << "\33[0;1;35mMonster kuoli, yritetn uudestaan liikkumista (suunta: '" << dir << "')\33[m\n";
			//cerr << "\33[0;32m> loot\33[m\n";
			//cerr << "\33[0;32m> ga\33[m\n";
			cout << "loot\nga\n";
			goto Retry;
		}
		vector<string> lst = GetExits(s);
		if(!lst.size())continue;
		for(unsigned a=0; a<lst.size(); ++a)
			if(lst[a] != opposite)
			{
				cerr << "\33[0;35mExits: \33[1m";
				unsigned b;
				for(b=0; b<lst.size(); ++b)
				{
					if(b > 0)cerr << "\33[21m, \33[1m";
					if(b==a)cerr << "\33[31m";
					else if(lst[b]==opposite)cerr << "\33[34m";
					else cerr << "\33[35m";
					cerr << lst[b];
				}
				cerr << "\33[m\n";				
				ScanRoom(lst[a]);
			}
		break;
	}
RetryBack:
	Regen();
	cerr << "\33[0;1;34m<- '" << opposite << "'\33[m\n";
	if(opposite.size())
	{
        cout << opposite << "\n";
        //cerr << "\33[0;32m> " << opposite << "\33[m\n";
        for(;;)
        {
        	string s = Gets();
        	cerr << s << endl;
        	if(s=="You are so exhausted you fail to move.")
        	{
        		goto RetryBack;
        	}
        	if(gotfight(s))
        	{
        		cerr << "\33[0;1;33mOdotellaan monsterin kuolemista\33[m\n";
        		fight();
        		cerr << "\33[0;1;33mMonster kuoli, yritetn uudestaan liikkumista (suunta: '" << opposite << "')\33[m\n";
        		//cerr << "\33[0;32m> loot\33[m\n";
        		//cerr << "\33[0;32m> ga\33[m\n";
        		cout << "loot\nga\ndrop all corpse\n";
        		goto RetryBack;
        	}
        	if(GetExits(s).size())break;
		}
	}
}

int main(void)
{
	cout << TUNNUS<<"\n"<<SALASANA<<"\n";
	
	cout << "command doclw cast cure light wounds at me\n"
	        "set echo off\n"
	        "battle listen all 1\n"
    	    "pc miaow\n";
	
	try
	{
Alustauusix:
		cout << "sc off\n"
		        "i\n"
		        "prompt hp:<hp>/<maxhp> sp:<sp>/<maxsp> ep:<ep>/<maxep> exp:<exp> kg:<weight> cash:<cash>+<bank><lf>_\n";
    	for(;;)
    	{
    		string s = Gets();
    		cerr << s << endl;
    		if(s.find("Your prompt is now") != s.npos)break;
    	}
    	ScanRoom("blook");
    	goto Alustauusix;
	}
	catch(int i)
	{
		if(i==1)
		{
			cerr << "\33[0;44;1;37mOuch, uusiksi vaan\n";
			goto Alustauusix;
		}
	}
	cout << "sc off\n"
	        "set echo on\n"
	        "prompt <lf>hp:<hp>/<maxhp> sp:<sp>/<maxsp> ep:<ep>/<maxep> exp:<exp> cash:<cash>+<bank><lf>up<hour>:<min>>_\n"
	        "ld Byebye\n";
	sleep(25);
	return 0;
}


/*

prompt <lf>hp:<hp>/<maxhp> sp:<sp>/<maxsp> ep:<ep>/<maxep> exp:<exp> cash:<cash>+<bank><lf>up<hour>:<min>>_

*/